# Dyson's Fear

Something has caused a runaway chain reaction on your space station and now you're running for your life from a massive explosion! There's just one problem - there's only so much space station to run through - but there are intelligent wrenches that can build additional sections of the station laying around. How long can you sprint from the flames without running out of ship and flying into the vastness of space? Don't panic! This is *Dyson's Fear*.

## What is this?

This project is a Gameboy game written for the Ludum Dare 42 game jam, which had the theme "running out of space". It was written almost entirely from scratch (some library functions were pre-written) in 72 hours. Notably, the game is written entirely in assembly.

## How do I get it?

Once we have a release up on GitHub, you can download the ROM from the releases page. If that hasn't happened yet or you want the latest version of the code, you can clone this repo and build it yourself.

## How do I build it?

This project is built with the [RGBDS toolchain](https://github.com/rednex/rgbds) and requires a `make`. Install RGBDS and run `make` in the root directory. This will produce a `.gb` file which you can run in an emulator or your own Gameboy with the proper hardware.

## Why would you do this?

For fun! We thought writing a Gameboy game would be a good test of our knowledge of the platform.

## Who are you?

A couple of friends that enjoy homebrew. Specifically:
- Nicholas Flynt - systems and physics programmer
- Cristián Romo - artist and effects programmer

## What's with the license?

It's GPL3 since we figure that the code will likely be used more for educational purposes than churning out the next blockbuster.